import uvicorn

import uiautomator2 as u2
from app import *
from api.base import *

@app.get("/health", response_model=Response)
def health():
    return Response()


@app.post("/device/connect", response_model=Response)
def connect_device(item: Device):
    try:
        d = u2.connect(item.serial)
    except Exception as e:
        return Response(code=500, msg=str(e))
    print(d.info)
    print(d.device_info)
    devices[item.serial] = d
    return Response(data=d.device_info)


@app.post("/device/size", response_model=Response)
def get_device_size(item: Device):
    if item.serial not in devices:
        return Response(code=500, msg="设备 {} 不存在".format(item.serial))

    d = devices[item.serial]
    width, height = d.window_size()
    return Response(data={
        "width": width,
        "heighth": height,
    })




if __name__ == '__main__':
    uvicorn.run('main:app', host='0.0.0.0', port=8000, reload=True)
